﻿#target illustrator
#targetengine ill
function selfTalk(func, args){
  var bt = new BridgeTalk();
  bt.target = BridgeTalk.appName;
  args = (args !== undefined) ? args.toSource().toString().slice(1, -1) : "";
  bt.body = func.toSource()+"("+ args +");";
  bt.send();
};

var win = new Window("palette","サイズで前後");
var panel = win.add("panel", undefined, "比較部分");
var selector = panel.add("dropDownList",undefined,"比較部分");
selector.opts = [];
selector.opts.push(selector.add("item","面積"));
selector.opts.push(selector.add("item","幅"));
selector.opts.push(selector.add("item","高さ"));
selector.opts[0].selected=true;

var buttonGroup1 = win.add("group");
buttonGroup1.orientation = "column";
btnL = buttonGroup1.add("button", undefined, "大きい方を前面に");
btnS = buttonGroup1.add("button", undefined, "小さい方を前面に");

btnL.onClick = function(){
    triger(8);
};

btnS.onClick = function(){
    triger(2);
};


win.show();

function triger(frontDirection){
selfTalk(function(basePoint,frontDirection){
    var selectedItems = app.activeDocument.selection;
    var allLayers = getAllLayers(app.activeDocument);
    var layerObjects = [];
    for(var i=0;i<allLayers.length;i++){
        for(var j=0;j<selectedItems.length;j++){
            if(allLayers[i].zOrderPosition == selectedItems[j].layer.zOrderPosition){
                if(typeof(layerObjects[i]) == "undefined"){
                    layerObjects[i] = [];
                }
                layerObjects[i].push(selectedItems[j]);
            }
        }
    }
    for (var layerKey in layerObjects){
        /*比較部分*/
        compareSize = [];
        for (var itemKey in layerObjects[layerKey]){
            tempCompareSize = {};
            tempCompareSize.key = itemKey;
            tempCompareSize.area = layerObjects[layerKey][itemKey].width*layerObjects[layerKey][itemKey].height;
            if(basePoint == 1){
                tempCompareSize.area = layerObjects[layerKey][itemKey].width;
            }
            if(basePoint == 2){
                tempCompareSize.area = layerObjects[layerKey][itemKey].height;
            }
            compareSize.push(tempCompareSize);
        }
        /*ソート*/
        compareSize.sort(function(a,b){
            if(frontDirection == 8){
                if(a.area < b.area) return -1;
                if(a.area > b.area) return 1;
                if(a.area == b.area){
                    if(Number(a.key) < Number(b.key)) return 1;
                }
                return 0;
            }else{
                if(a.area > b.area) return -1;
                if(a.area < b.area) return 1;
                if(a.area == b.area){
                    if(Number(a.key) < Number(b.key)) return 1;
                }
                return 0;
            }
        });
        for (var itemKey=0;itemKey<compareSize.length;itemKey++){
            if(itemKey>0){
                layerObjects[layerKey][compareSize[itemKey].key].move(layerObjects[layerKey][compareSize[itemKey-1].key],ElementPlacement.PLACEBEFORE);
            }
        }
    }
    function getAllLayers(dl){
        var ret = [];
        var layers = dl.layers;
        for(var i=0;i<layers.length;i++){
            ret.push(layers[i]);
            if(layers[i].layers.length>0){
            ret.push(getAllLayers(layers[i]));
            }
        }
    return ret;
    }
  },
  [selector.selection.index,frontDirection]
  );
}

